#include <SoftwareSerial.h>
//#include "base64.hpp"
#include <TinyGPSPlus.h>

SoftwareSerial SIM7000E(2, 3); // RX, TX


#define PWR_Pin 6


String ntripUsername = "info@raycorp.nl";
String ntripPassword = "";
String gpsString = "";

// Send NMEA sentence toSIM7000E
void setup() {
  Serial.begin(9600);
  SIM7000E.begin(9600);

  pinMode(PWR_Pin, OUTPUT);
  digitalWrite(PWR_Pin, HIGH);
  delay(500);
  digitalWrite(PWR_Pin, LOW);
  delay(2000);

  sendATCommand("AT"); // Test AT command
  sendATCommand("AT+CGATT=1"); // Attach to GPRS service
  sendATCommand("AT+CGDCONT=1,\"IP\",\"public.m2m\""); // Set APN
  sendATCommand("AT+CGPSPWR=1");
  delay(2000);

  // Enable NTP time synchronization (optional)
  sendATCommand("AT+CNTPCID=1");
  sendATCommand("AT+CNTP=\"pool.ntp.org\"");

  // Connect to GPRS network
  sendATCommand("AT+CGACT=1,1");
  delay(2000);

  // Open TCP/IP connection to NTRIP server
  sendATCommand("AT+CIPSTART=\"TCP\",\"www.rtk2go.com\",2101");
  delay(3000);

  String credentials = ntripUsername + ":" + ntripPassword;
  String base64Credentials = base64Encode(credentials.c_str(), credentials.length());
  //Serial.print(base64Credentials);
  //
  //////  // Send NTRIP request headers
  sendATCommand("AT+CIPSEND");
  delay(1000);
  SIM7000E.println("GET /Allesbeste HTTP /1.1");
  SIM7000E.println("User-Agent: Test4g NTRIP");
  SIM7000E.print("Authorization: Basic" + base64Credentials);
  SIM7000E.println("Ntrip-Version: Ntrip/2.0");
  SIM7000E.println("Connection: close");
  SIM7000E.write(0x1A);
  delay(1000);


 
}


void loop() {
  
  while (SIM7000E.available()) {
    if (SIM7000E.available()) {  // Check if there is any serial data available
      String inputString = "";  // Create an empty string to store the input

      while (SIM7000E.available()) {
        char c = SIM7000E.read();  // Read a character from the serial buffer

        if (c == '\n') {  // Check for a newline character to indicate the end of the input
          break;
        }

        inputString += c;  // Append the character to the input string

      }
      Serial.println(inputString);
      if (inputString.indexOf("ENDSOURCETABLE") >= 0) {
        Serial.println("downloaded Source table!!");
        //

        // Start sending GGA data!!

      }
    }
  }
}








void sendATCommand(String command) {
  SIM7000E.println(command);
  delay(500);
  while (SIM7000E.available()) {
    Serial.write(SIM7000E.read());
  }
}



const char base64Chars[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
String base64Encode(const char* input, size_t length) {
  String encoded;
  encoded.reserve(((length + 2) / 3) * 4);

  for (size_t i = 0; i < length; i += 3) {
    uint32_t chunk = (input[i] << 16) | ((i + 1 < length ? input[i + 1] : 0) << 8) | ((i + 2 < length ? input[i + 2] : 0));

    encoded += base64Chars[(chunk >> 18) & 63];
    encoded += base64Chars[(chunk >> 12) & 63];
    encoded += base64Chars[(chunk >> 6) & 63];
    encoded += base64Chars[chunk & 63];
  }

  size_t padding = length % 3;
  if (padding > 0) {
    encoded[encoded.length() - 1] = '=';
    if (padding == 1)
      encoded[encoded.length() - 2] = '=';
  }

  return encoded;
}
